Subject: Re: [PATCH 0/3] macvlan: support for guest vm direct rx/tx

From: Stephen Hemminger <[email-masked]>
Date: Fri, 27 Nov 2009 21:38:24 -0800

On Fri, 27 Nov 2009 16:19:57 -0800 (PST)
David Miller <[email-masked]> wrote:

> From: Arnd Bergmann <[email-masked]>
> Date: Sat, 28 Nov 2009 00:43:58 +0100
> 
> > On Friday 13 November 2009, Stephen Hemminger wrote:
> >> Also, macvlan should really being calling netif_receive_skb()
> >> not going through another queue/softirq cycle.
> > 
> > I've added a patch for this in my experimental queue now.
> > When I last tried this, I saw a kernel stack overflow
> > but it seems fine now.
> 
> I think it is unwise for any virtual device layer to use netif_receive_skb().
> Just like tunnels they should always use netif_rx().
> 
> Otherwise stack overflow is a very real concern.

Maybe we should figure out a way for protocols to return new skb in netif_receive_skb
to avoid extra softirq, but avoid stack overflow?

--